include "wsdl.grm"

redefine program 
		...
	|	[repeat fact]
end redefine

define fact
		[SPOFF] [repeat id_dot] [id] [SPON]																[NL]
	|	[id]																							[NL]
end define 

define id_dot
	[id] '.
end define

function main
	replace [program]
		P [program]
	
	construct Service [repeat service]
		_ [^ P] 
	deconstruct Service
		'< _ [opt prefix] 'service AttrList [opt attribute_list] '>
			_ [repeat service_scope] 
		'</ _ [opt prefix] 'service>
	construct ServiceNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct ServiceNameAttr
		_ [opt prefix] 'name = ServiceNameWithPrefix [stringlit] 
		_ [repeat name_attr]
	construct ServiceNameNoPrefix [stringlit] 
		ServiceNameWithPrefix [deletePrefix]
	construct ServiceName [id] 
		_ [unquote ServiceNameNoPrefix]
	
	construct Types [repeat types]
		_ [^ P] 
	construct ComplexTypes [repeat complex_type]
		_ [^ Types]
	
	construct Facts [repeat fact]
		_ [getTypes ServiceName each ComplexTypes]
	
	by 
		Facts
end function 

function getTypes ServiceName [id] Type [complex_type]
	replace [repeat fact]
		PreviousFacts [repeat fact]
	deconstruct Type
		'< _ [opt prefix] 'complexType AttrList [opt attribute_list] '> 
			_ [repeat complexType_scope] 
		'</ _ [opt prefix] 'complexType>
	construct TypeNameAttr [repeat name_attr]
		_ [^AttrList]
	deconstruct TypeNameAttr
		_ [opt prefix] 'name = Name [stringlit] 
		_ [repeat name_attr]	
	construct TypeNameNoPrefix [stringlit]
		Name [deletePrefix]
	construct TypeName [id]
		_ [unquote TypeNameNoPrefix]
		
	construct NewFact [fact]
		ServiceName '. TypeName
	by 
		PreviousFacts [. NewFact]
end function

function deletePrefix 
	replace [stringlit]
		NameWithPrefix [stringlit]
	construct IndexOfColon [number]
		_ [index NameWithPrefix ":"] [+ '1]
	deconstruct not IndexOfColon
		1
	by
		NameWithPrefix [: IndexOfColon 999]
end function
