include "wsdl.grm"

redefine program 
		...
	|	[repeat fact]
end redefine

define fact
	[repeat id_or_id_dot]																			[NL]
end define 

define id_or_id_dot
		[SPOFF] [id] '. [id] '. [id] [SPON]	[SP]
	|	[SPOFF] [id] '. [id] [SPON]	[SP]
	|	[id] [SP]
end define

function main
	replace [program]
		P [program]
	
	construct Service [repeat service]
		_ [^ P] 
	deconstruct Service
		'< _ [opt prefix] 'service AttrList [opt attribute_list] '>
			_ [repeat service_scope] 
		'</ _ [opt prefix] 'service>
	construct ServiceNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct ServiceNameAttr
		_ [opt prefix] 'name = ServiceNameWithPrefix [stringlit] 
		_ [repeat name_attr]
	construct ServiceNameNoPrefix [stringlit] 
		ServiceNameWithPrefix [deletePrefix]
	construct ServiceName [id] 
		_ [unquote ServiceNameNoPrefix]
	
	construct PortType [repeat port_type]
		_ [^ P] 
	construct Ops [repeat operation]
		_ [^ PortType]
	
	construct Facts [repeat fact]
		_ [getOps ServiceName each Ops]
	
	by 
		Facts
end function 

function getOps ServiceName [id] Op [operation]
	replace [repeat fact]
		PreviousFacts [repeat fact]
	deconstruct Op
		'< _ [opt prefix] 'operation AttrList [opt attribute_list] '>
			_ [repeat operation_scope]
		'</ _ [opt prefix] 'operation> 
	construct OpNameAttr [repeat name_attr]
		_ [^AttrList]
	deconstruct OpNameAttr
		_ [opt prefix] 'name = OpNameWithPrefix [stringlit] 
		_ [repeat name_attr]
	construct OpNameNoPrefix [stringlit] 
		OpNameWithPrefix [deletePrefix]
	construct OpName [id] 
		_ [unquote OpNameNoPrefix]
	construct NewFact [fact]
		'provides ServiceName ServiceName '. OpName
	by 
		PreviousFacts [. NewFact]
end function

function deletePrefix 
	replace [stringlit]
		NameWithPrefix [stringlit]
	construct IndexOfColon [number]
		_ [index NameWithPrefix ":"] [+ '1]
	deconstruct not IndexOfColon
		1
	by
		NameWithPrefix [: IndexOfColon 999]
end function
